/* 
    This program calculates the expectaton value of the radius of
    a hydrogen atom wavefunction using a recursive relation. 
    Given that for n=1 and l=0, <r> = 3a/2
*/


#define _USE_MATH_DEFINES 
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>

int rnl(int n, int l)
  {
    if (l==0) 
      return (3*n*n);    /* <r> = 3(n*n) when l = 0  */
    else return rnl(n, (l-1)) - 2*l;
  }
   
int main(void)
  {
    int n; /* n is the principal quantum number                */
    int l; /* l is the orbital angular momentum quantum number */
    
    for(n=1; n<=5; n++)    /* calculate <r> from n=1 to n=5 for every l  */
      {
        for(l=0; l<=n-1; l++)
           printf("Quantum Numbers: n=%d l=%d  <r>=%da/2 \n",n,l,rnl(n,l));
           
        printf("\n");
      };
    printf("      Press any key to end");
    while(!_getch() );
  }
